#include <hidef.h> /* for EnableInterrupts macro */
#include "derivative.h" /* include peripheral declarations */

#include "LIB_LCD.h"

extern void LCD_init(void);

extern void MTIM_init(void);

extern void DisplayMessage(void);

extern void DisplayTime(void);

extern void TPM_init(void);

extern void KBI_init(void);

extern void ICS_init(void);

#define MODE_MESSAGE  0

#define MODE_TIME     1

unsigned char mode;

extern void Tick(void);

void main(void) {

  EnableInterrupts; /* enable interrupts */
  /* include your code here */
  SOPT = SOPT_STOPE_MASK | SOPT_BKGDPE_MASK | SOPT_RSTPE_MASK;
  
  mode = MODE_MESSAGE;
  
  ICS_init();
  
  KBI_init();
  
  LCD_init();
  
  MTIM_init();
  
  TPM_init();
  
  DisplayMessage();
  
  for (;;) {
  
    asm wait;
    
    if (SIP1_MTIM) {
      MTIMSC;
      MTIMSC_TOF = 0;
      
      Tick();

      if (mode)
        DisplayTime();
      
      if (!mode)
        DisplayMessage();
      
      continue;
    }
    
    if (SIP1_KBI) {
    
      KBISC_KBACK = 1;
      
      mode ^= 1;
      
      continue;
    }
  
  }

}
